
__global__ void Lcc7stateUpdate(FLOAT (*cd), int (*Nl), int (*Nlc), int (*Nlc2),int (*Nli), int (*Nli2), int (*Nlb1), int (*Nlb2), FLOAT (*lfire), int (*dfun),unsigned (*seed_d1),unsigned (*seed_d2),unsigned (*seed_d3),unsigned (*seed_d4) ,const FLOAT mdt, const FLOAT v, const unsigned int nxnynz, const FLOAT t){


const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  

 
 
if (idx<nxnynz && dfun[idx]==1){

    FLOAT s1,k1,s2,fc,k3,k3p,k4,k4p,k5,k5p,k6,k6p,tauCa,tauBa,TCa,Rv,Pr,Ps;
    FLOAT s12,s13,s21,s24,s25,s31,s36,s42,s45,s47,s52,s54,s57,s63,s67,s74,s75,s76,s34,s43,mlogr1,r1,r2,wt,rtest,tloc;
    FLOAT vnew=v;   


    #ifdef MAKE_SPARK
    //for sparking a cluster
     const unsigned int xcoord = (idx)%Nx;
     const unsigned int ycoord = int(floorf(idx/Nx))%Ny;
     const unsigned int zcoord = floorf(idx/Nx/Ny);
    
     if ( (t<=MAKE_SPARK+SPARK_DUR && t>=MAKE_SPARK) && (xcoord>=SPARKX_START && xcoord<=SPARKX_END) && (ycoord>=SPARKY_START && ycoord<=SPARKY_END) && (zcoord>=SPARKZ_START && zcoord<=SPARKZ_END) )  
           {vnew=0;}
     ;
    #endif

   
             FLOAT expmv_8=EXP(-vnew/8.0); 
             FLOAT alphalcc=1.0/(1.0+expmv_8);
             FLOAT betalcc=expmv_8/(1.0+expmv_8);
             fc=1.0/(1.0+POW(cdbar/cd[idx],3));
             k1=0.03*fc;
             k3=EXP(-(vnew+40.0)/3.0)/(3.0*(1.0+EXP(-(vnew+40.0)/3.0)));
             Rv=10.0+4954.0*EXP(vnew/15.6);
             TCa=(78.0329+0.1*POW(1.0+cd[idx]/0.5,4))/(1.0+POW(cd[idx]/0.5,4));//TCa=(78.0329+0.1*POW(1.0+cd[idx]/6.09365,4))/(1.0+POW(cd[idx]/6.09365,4));//TCa=(78.0329+0.1*POW(1.0+cd[idx]/cdbar,4))/(1.0+POW(cd[idx]/cdbar,4));
             Ps=1.0/(1.0+EXP(-(vnew+40.0)/11.32));
             Pr=1.0/(1.0+EXP(-(vnew+40.0)/4));
             tauCa=(Rv-TCa)*Pr+TCa;
             tauBa=(Rv-TBa)*Pr+TBa;
             k5=(1-Ps)/tauCa;
             k6=fc*Ps/tauCa;
             k5p=(1-Ps)/tauBa;
             k6p=Ps/tauBa;
             k3p=k3;
             k4=k3*(k1/k2)*(k5/k6)/expmv_8;
             k4p=k3p*(k1p/k2p)*(k5p/k6p)/expmv_8;
             s1=0.02*fc;
             s2=s1*(k2/k1)*(rr1/rr2);
          
             s12=Nli2[idx]*k4;
             s13=s12+Nli2[idx]*k5;
             s21=s13+Nli[idx]*k3;
             s24=s21+Nli[idx]*k2;
             s25=s24+Nli[idx]*s2;
             s31=s25+Nlc2[idx]*k6;
             s36=s31+Nlc2[idx]*k6p;
             s34=s36+Nlc2[idx]*alphalcc;
             s43=s34+Nlc[idx]*betalcc;
             s42=s43+Nlc[idx]*k1;
             s45=s42+Nlc[idx]*rr1;
             s47=s45+Nlc[idx]*k1p;
             s52=s47+Nl[idx]*s1;
             s54=s52+Nl[idx]*rr2;
             s57=s54+Nl[idx]*s1p;
             s63=s57+Nlb2[idx]*k5p;
             s67=s63+Nlb2[idx]*k4p;
             s74=s67+Nlb1[idx]*k2p;
             s75=s74+Nlb1[idx]*s2p;
             s76=s75+Nlb1[idx]*k3p;
             //lamtot=s76;
             //lam1=Nli[idx]*tempnum1;
             //lam2=Nli[idx]*tempnum1+Nlc[idx]*tempnum2;
             //lam3=Nli[idx]*tempnum1+Nlc[idx]*tempnum2+Nlc[idx]*tempnum3;
             //lamtot=lam3+Nl[idx]*tempnum4;
             
             rtest=lfire[idx]-s76*mdt;
                           
             if (rtest<=0){

              tloc=lfire[idx]/s76;
              r2=s76*HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
              if (r2<=s12 ) { Nli2[idx]-=1;Nli[idx]+=1; }
              else if ( r2<=s13 ) {Nli2[idx]-=1;Nlc2[idx]+=1;}
              else if ( r2<=s21 ) { Nli[idx]-=1;Nli2[idx]+=1; }
              else if ( r2<=s24 ) { Nli[idx]-=1;Nlc[idx]+=1; }
              else if ( r2<=s25 ) { Nli[idx]-=1;Nl[idx]+=1; }
              else if ( r2<=s31 ) { Nlc2[idx]-=1;Nli2[idx]+=1; }
              else if ( r2<=s36 ) { Nlc2[idx]-=1;Nlb2[idx]+=1; }
              else if ( r2<=s34 ) { Nlc2[idx]-=1;Nlc[idx]+=1; }
              else if ( r2<=s43 ) { Nlc[idx]-=1;Nlc2[idx]+=1; }
              else if ( r2<=s42 ) { Nlc[idx]-=1;Nli[idx]+=1; }
              else if ( r2<=s45 ) { Nlc[idx]-=1;Nl[idx]+=1; }
              else if ( r2<=s47 ) { Nlc[idx]-=1;Nlb1[idx]+=1; }
              else if ( r2<=s52 ) { Nl[idx]-=1;Nli[idx]+=1; }
              else if ( r2<=s54 ) { Nl[idx]-=1;Nlc[idx]+=1; }
              else if ( r2<=s57 ) { Nl[idx]-=1;Nlb1[idx]+=1; }
              else if ( r2<=s63 ) { Nlb2[idx]-=1;Nlc2[idx]+=1; }
              else if ( r2<=s67 ) { Nlb2[idx]-=1;Nlb1[idx]+=1; }
              else if ( r2<=s74 ) { Nlb1[idx]-=1;Nlc[idx]+=1; }
              else if ( r2<=s75 ) { Nlb1[idx]-=1;Nl[idx]+=1; }
              else  {Nlb1[idx]-=1;Nlb2[idx]+=1;};

              s12=Nli2[idx]*k4;
              s13=s12+Nli2[idx]*k5;
              s21=s13+Nli[idx]*k3;
              s24=s21+Nli[idx]*k2;
              s25=s24+Nli[idx]*s2;
              s31=s25+Nlc2[idx]*k6;
              s36=s31+Nlc2[idx]*k6p;
              s34=s36+Nlc2[idx]*alphalcc;
              s43=s34+Nlc[idx]*betalcc;
              s42=s43+Nlc[idx]*k1;
              s45=s42+Nlc[idx]*rr1;
              s47=s45+Nlc[idx]*k1p;
              s52=s47+Nl[idx]*s1;
              s54=s52+Nl[idx]*rr2;
              s57=s54+Nl[idx]*s1p;
              s63=s57+Nlb2[idx]*k5p;
              s67=s63+Nlb2[idx]*k4p;
              s74=s67+Nlb1[idx]*k2p;
              s75=s74+Nlb1[idx]*s2p;
              s76=s75+Nlb1[idx]*k3p;
              //lamtot=s76;
        
              r1=HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
              mlogr1=-LOG(r1);
              wt=mlogr1/s76;
              tloc+=wt;//need + if tloc =-rtest above
                        

              while (tloc<mdt){ //cout<<cd[idx]<<" "<<tempnum2<<endl;

                r2=s76*HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
                if (r2<=s12 ) { Nli2[idx]-=1;Nli[idx]+=1; }
                else if ( r2<=s13 ) {Nli2[idx]-=1;Nlc2[idx]+=1;}
                else if ( r2<=s21 ) { Nli[idx]-=1;Nli2[idx]+=1; }
                else if ( r2<=s24 ) { Nli[idx]-=1;Nlc[idx]+=1; }
                else if ( r2<=s25 ) { Nli[idx]-=1;Nl[idx]+=1; }
                else if ( r2<=s31 ) { Nlc2[idx]-=1;Nli2[idx]+=1; }
                else if ( r2<=s36 ) { Nlc2[idx]-=1;Nlb2[idx]+=1; }
                else if ( r2<=s34 ) { Nlc2[idx]-=1;Nlc[idx]+=1; }
                else if ( r2<=s43 ) { Nlc[idx]-=1;Nlc2[idx]+=1; }
                else if ( r2<=s42 ) { Nlc[idx]-=1;Nli[idx]+=1; }
                else if ( r2<=s45 ) { Nlc[idx]-=1;Nl[idx]+=1; }
                else if ( r2<=s47 ) { Nlc[idx]-=1;Nlb1[idx]+=1; }
                else if ( r2<=s52 ) { Nl[idx]-=1;Nli[idx]+=1; }
                else if ( r2<=s54 ) { Nl[idx]-=1;Nlc[idx]+=1; }
                else if ( r2<=s57 ) { Nl[idx]-=1;Nlb1[idx]+=1; }
                else if ( r2<=s63 ) { Nlb2[idx]-=1;Nlc2[idx]+=1; }
                else if ( r2<=s67 ) { Nlb2[idx]-=1;Nlb1[idx]+=1; }
                else if ( r2<=s74 ) { Nlb1[idx]-=1;Nlc[idx]+=1; }
                else if ( r2<=s75 ) { Nlb1[idx]-=1;Nl[idx]+=1; }
                else  {Nlb1[idx]-=1;Nlb2[idx]+=1;};

                s12=Nli2[idx]*k4;
                s13=s12+Nli2[idx]*k5;
                s21=s13+Nli[idx]*k3;
                s24=s21+Nli[idx]*k2;
                s25=s24+Nli[idx]*s2;
                s31=s25+Nlc2[idx]*k6;
                s36=s31+Nlc2[idx]*k6p;
                s34=s36+Nlc2[idx]*alphalcc;
                s43=s34+Nlc[idx]*betalcc;
                s42=s43+Nlc[idx]*k1;
                s45=s42+Nlc[idx]*rr1;
                s47=s45+Nlc[idx]*k1p;
                s52=s47+Nl[idx]*s1;
                s54=s52+Nl[idx]*rr2;
                s57=s54+Nl[idx]*s1p;
                s63=s57+Nlb2[idx]*k5p;
                s67=s63+Nlb2[idx]*k4p;
                s74=s67+Nlb1[idx]*k2p;
                s75=s74+Nlb1[idx]*s2p;
                s76=s75+Nlb1[idx]*k3p;
                //lamtot=s76;

                r1=HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
                mlogr1=-LOG(r1);
                wt=mlogr1/s76;
                
                tloc+=wt;  
  
              };
              //lfire[idx]=mlogr1;
                lfire[idx]=mlogr1+s76*(-mdt+tloc-wt);
           }
           else {lfire[idx]=rtest;}; 
          



};


}
